// ==UserScript==
// @name Security Policy script
// @author deepakp
// @namespace  
// @version 1.0
// @description  Attempts to define security polcies using UserJS. Security Policies are for access control, script restrictions and to allows cross-domain comm
// @ujs:category browser: security
// @ujs:published 2008-04-14 02:10
// @ujs:modified 
// @ujs:documentation
// @ujs:download
// @exclude file://localhost/D:/Deepak/My%20Documents/Deepak/workbench/thesis/Source%20Code/index.html
// @include file://localhost/D:/Deepak/My%20Documents/Deepak/workbench/thesis/Source%20Code/*
// ==/UserScript==

/* 
 * Public Domain
 */

// SecurityPolicyDefinition
// @scriptPolicy = "all", "internal", "external", "head", "body", "none";
// @scriptSource = "file://localhost/";
// /SecurityPolicyDefinition

var StatisticsInfo = {
	scriptcount 		: 0,
	scriptextcount 		: 0,
	scriptjsurlcount	: 0,
	scriptblocked 		: 0,
	scriptextblocked	: 0,
	scriptjsurlblocked 	: 0,
	sandboxcount		: 0,
	objectcount			: 0,
	objectblocked		: 0
};
 
var startt = new Date();
var timekeeper = 0;

function TimeKeeper() {
	this.startTime = new Date();
	
	this.stop = function() {
		return (new Date()-this.startTime);
	};
}

// Variables and Custom Objects
var secPolicy; // our protagonist object

var isDeebug = true;

var SPDefinition = {
	version 		: "SecurityPolicy:version",
	locationkeyword : "location",
	scriptPolicy 	: "SecurityPolicy:scriptPolicy",
	scriptSource 	: "SecurityPolicy:scriptSource",
	sourceWhitelist : "SecurityPolicy:sourceWhitelist",
	sandBox			: "SecurityPolicy:sandbox"
};
 
function SecurityPolicy(){
	this.version = "";
	this.scriptPolicy = "all";
	this.scriptSource;
	this.sourceWhitelist = "";
}
// End of Variables and Custom Objects

// Debug Function

var consoleRef;

// Debug Console, courtsey Jeff P Bigham. http://www.manticmoo.com/articles/jeff/programming/javascript/virtual-javascript-console-for-debugging.php
function writeConsole(content) {
	if(!(consoleRef)) {
		consoleRef=window.open('','debugconsole','width=350,height=250'+',menubar=0'+',toolbar=1'+',status=0'+',scrollbars=1'+',resizable=1');
		consoleRef.document.writeln('<html><head><title>Debug Console</title></head>'+'<body bgcolor=white onLoad="self.focus()"><h><br />Debug Console</h1>'+ '</body></html>');
	}
	consoleRef.document.body.innerHTML += "<br />" + content;  
}

function deebugp1(msg, value)
{
	//var timek = new TimeKeeper();  

	if(isDeebug === true) 
	{	
		writeConsole(msg + ' - ' + value);
	}

	//timekeeper += timek.stop();	
}

function deebugp(msg)
{
	//var timek = new TimeKeeper();  

	if(isDeebug === true) 
	{	
		writeConsole(msg);
	}

	//timekeeper += timek.stop();	
}

// End of Debug Functions

function initPolicy(){
	var timek = new TimeKeeper();
	//deebugp('initPolicy enter');
	
	secPolicy = new SecurityPolicy();
	var metaArray = document.getElementsByTagName('meta');
	for (var i=0; i<metaArray.length; i++) {
		
		if(metaArray[i].name != "")
		if(SPDefinition.version.indexOf(metaArray[i].name) >= 0)
		{
			secPolicy.version = metaArray[i].content;//getAttribute('content');
			deebugp1('secPolicy:version', secPolicy.version);
		}
		else if(SPDefinition.scriptPolicy.indexOf(metaArray[i].name) >= 0)
		{
			secPolicy.scriptPolicy = metaArray[i].getAttribute('content');
			deebugp1('secPolicy:scriptPolicy', secPolicy.scriptPolicy);
		}
		else if(SPDefinition.scriptSource.indexOf(metaArray[i].name) >= 0)
		{
			var sourceextract = metaArray[i].getAttribute('content');
			deebugp1('secPolicy:scriptSource', sourceextract);
			
			var substrextract = sourceextract.replace(/\*/g, ".*").split(",");
			
			secPolicy.scriptSource = new Array();
			for(var x=0; x < substrextract.length; ++x)
			{
				if(substrextract[x] == SPDefinition.locationkeyword)
				{
					secPolicy.scriptSource[x] = new RegExp('^'+location.protocol+'\\\/\\\/'+location.hostname.replace(/\./g,'\\.')+'\\\/','i');
				}
				else
					secPolicy.scriptSource[x] = new RegExp(substrextract[x], 'i');
					
			}
		}
	}

	//deebugp('initPolicy leave');
	timekeeper = timekeeper + timek.stop();
}initPolicy();

function checkallowedsource(array, url)
{
	if(!array)
		return true;

	if(array.length == 1)
	if(array[0] == "")
		return true;

	for(var x=0; x < array.length; ++x)
	{
		if(array[x].test(url))
			return true;
	}

	return false;
}

function checkscriptlocation(location, script) 
{
	//deebugp('checkscriptlocation enter');
	//deebugp1('location', location);
	//deebugp1('script',script);

	var myBody = document.getElementsByTagName(location)[0];

	if(!myBody) { return false; } // no body loaded yet, so block head scripts

	var myScripts = myBody.getElementsByTagName("script");

	for(var x = 0; x < myScripts.length; ++x){
		if(myScripts[x] == script){
			//deebugp('Script Found!!');
			return true;
		}
	}

	return false;	
}

function checkjsurllocation(location, script) 
{
	//deebugp('checkjsurllocation enter');
	//deebugp1('location', location);
	//deebugp1('script',script);

	var myBody = document.getElementsByTagName(location)[0];
	
	if(!myBody) { return false; } // no body loaded yet, so block head scripts
	
	if(myBody.innerHTML.indexOf(script) >= 0){
			//deebugp('Script Found!!');
			return true;
	}
	
	return false;	
}
 
function checksandbox(script)
{
	//deebugp('checksandbox enter');
	
	if(!script.source) //not JS URL
	{
		if(script.parentNode.nodeName == 'DIV')
		{
			if(script.parentNode.getAttribute('class') == SPDefinition.sandBox)
			{
				//deebugp('Sandbox Found!');
				StatisticsInfo.sandboxcount++;
				return true;
			}
		}
	}
	else // JS URL
	{
		var myDivs = document.getElementsByTagName('div');
		for(var i = 0; i < myDivs.length; ++i)
		{
			if(myDivs[i].getAttribute('class') == SPDefinition.sandBox)
			{
				if(myDivs[i].innerHTML.indexOf(script.source) >= 0)
				{
					//deebugp('Sandbox Found!');
					StatisticsInfo.sandboxcount++;
					return true;				
				}
			}
		}
	}		

	return false;		
}

function checkscriptpolicy(script) {
	//deebugp('checkscriptpolicy enter');
	
	if(!secPolicy) 
	{
		return false;
	}
	
	if(secPolicy.scriptPolicy.indexOf("all") >= 0)
	{
		//deebugp('Policy - all');
		if(checksandbox(script) === true)
		{
			return true;
		}
		
		return false;
	}
	else if(secPolicy.scriptPolicy.indexOf("none") >= 0)
	{
		//deebugp('Policy - none');
		return true;
	}
	else if(secPolicy.scriptPolicy.indexOf("head") >= 0 || secPolicy.scriptPolicy.indexOf("body") >= 0)//head, body
	{
		var location;
		if(secPolicy.scriptPolicy.indexOf("head") >= 0)
		{
			location = "head";
		}
		else if(secPolicy.scriptPolicy.indexOf("body") >= 0)
		{
			location = "body";
		}
			
		//deebugp1('Policy', location)
		
		var isAllowed;
		
		if(script.source) // JS URL
		{
			isAllowed = checkjsurllocation(location, script.source);
		}
		else
		{
			isAllowed = checkscriptlocation(location, script);
		}

		if(isAllowed === false)
		{
			return true;
		}
	}
	else //  only internal, external flags. no other flag used. default to all.
	{
		//deebugp('Policy - all');
		if(checksandbox(script) === true)
		{
			return true;
		}
		
		return false;	
	}
	
	if(checksandbox(script) === true)
	{
		return true;
	}
	
	return false;
}

//JavascriptURL
window.opera.addEventListener( 'BeforeJavascriptURL', 
function (e) 
{
	StatisticsInfo.scriptjsurlcount++;
	
	var timek = new TimeKeeper();  

	//deebugp('BeforeJavascriptURL enter'); 

	if(document.documentElement.innerHTML.indexOf(e.source) >= 0){ // script is inside the document
		if(secPolicy){
			if(secPolicy.scriptPolicy.indexOf("external") >= 0){
				e.preventDefault();
				timekeeper = timekeeper + timek.stop();	
				//deebugp('JS URL SCRIPT BLOCKED'); 
				StatisticsInfo.scriptjsurlblocked++;
				return;
			}		
		}
	}
	else // external script
	{
		if(secPolicy){
			if(secPolicy.scriptPolicy.indexOf("internal") >= 0){
				e.preventDefault();
				timekeeper = timekeeper + timek.stop();	
				//deebugp('JS URL SCRIPT BLOCKED'); 
				StatisticsInfo.scriptjsurlblocked++;
				return;
			}
		}
	}

	if(checkscriptpolicy(e)){
		e.preventDefault();
		StatisticsInfo.scriptjsurlblocked++;
		//deebugp('JS URL SCRIPT BLOCKED'); 
	}
	timekeeper = timekeeper + timek.stop();	
}
, false );

//BeforeScript
window.opera.addEventListener( 'BeforeScript', 
function (e) 
{
	StatisticsInfo.scriptcount++;
	var timek = new TimeKeeper();  

	//deebugp1('BeforeScript enter');

	if(e.element.text.indexOf("// @timer") >= 0){
		//deebugp('TIMER SCRIPT'); 
		return;
	}
				
	if(document.documentElement.innerHTML.indexOf(e.element.text) >= 0){ // script is inside the document
		if(secPolicy){
			if(secPolicy.scriptPolicy.indexOf("external") >= 0){
				e.preventDefault();
				timekeeper = timekeeper + timek.stop();	
				StatisticsInfo.scriptblocked++;
				//deebugp('SCRIPT BLOCKED'); 
				return;
			}		
		}
	}
	else // external script
	{
		if(secPolicy)
		{
			if(secPolicy.scriptPolicy.indexOf("internal") >= 0){
				e.preventDefault();
				timekeeper = timekeeper + timek.stop();	
				StatisticsInfo.scriptblocked++;
				//deebugp('SCRIPT BLOCKED'); 
				return;
			}
		}
	}
		
	if(checkscriptpolicy(e.element)){
			//deebugp('SCRIPT BLOCKED'); 
			e.preventDefault();
			StatisticsInfo.scriptblocked++;
		}
		
	timekeeper = timekeeper + timek.stop();	
}
, false );

//BeforeExternalScript
window.opera.addEventListener( 'BeforeExternalScript', 
function (e) 
{
	StatisticsInfo.scriptextcount++;
	
	var timek = new TimeKeeper();  

	//deebugp('BeforeExternalScript enter');
	
	if(secPolicy){
	
		if(!checkallowedsource(secPolicy.scriptSource, e.element.src)) //check if script source is valid
		{
			e.preventDefault();
			StatisticsInfo.scriptextblocked++;
			return;
		}
		
		if(secPolicy.scriptPolicy.indexOf("internal") >= 0){
			e.preventDefault();
			timekeeper = timekeeper + timek.stop();	
			//deebugp('EXTERNAL SCRIPT BLOCKED'); 
			StatisticsInfo.scriptextblocked++;
			return;
		}
	}
		
	if(checkscriptpolicy(e.element)){
			e.preventDefault();
			StatisticsInfo.scriptextblocked++;
		}
	timekeeper = timekeeper + timek.stop();	
}
, false );

document.addEventListener('load', function ()
{
	var matchThis = location.protocol+'//'+location.hostname + '/' + location.pathname;
	deebugp1('***WEB APP***', matchThis);
	// var match = location.protocol+'//'+location.hostname;
	// deebugp('location: ', location);
	// deebugp('location: ', matchThis);
	// deebugp('location: ', match);
	var t = (new Date() - startt);
	//deebugp1('***START TIME***', startt);
	deebugp1('***OVERHEAD TIME***', timekeeper);
	deebugp1('***TOTAL LOAD TIME***', t);
	deebugp1('***SCRIPT COUNT***', StatisticsInfo.scriptcount);
	deebugp1('***EXTERNAL SCRIPT COUNT***', StatisticsInfo.scriptextcount);
	deebugp1('***JSURL SCRIPT COUNT***', StatisticsInfo.scriptjsurlcount);
	deebugp1('***SCRIPT BLOCKED***', StatisticsInfo.scriptblocked);
	deebugp1('***EXTERNAL SCRIPT BLOCKED***', StatisticsInfo.scriptextblocked);
	deebugp1('***JSURL SCRIPT BLOCKED***', StatisticsInfo.scriptjsurlblocked);
	
}
, false);

document.addEventListener('dontload', function ()
{
	//var timek = new TimeKeeper();  

	//deebugp('ONLOAD');
	
		var matchThis = new RegExp('^'+location.protocol+'\\\/\\\/'+location.hostname.replace(/\./g,'\\.')+'\\\/','i');

		var x = 0;
		while( document.images[x] ) {
			if( document.images[x].src.indexOf("javascript:") < 0){
			if( !document.images[x].src.match(matchThis) ) {
				document.images[x].parentNode.removeChild(document.images[x]);
			}
			else{
				x++;
			}
			} else { x++; }
		}
		
		var y = [document.getElementsByTagName('iframe'), document.getElementsByTagName('frame')];
		for(x = 0; y[x]; x++){
			for(var z = 0; y[x][z]; z++)
			{
				if( y[x][z].getAttribute('src').indexOf("javascript:") < 0){
					if( !y[x][z].getAttribute('src').match(matchThis) ){
						y[x][z].parentNode.removeChild(y[x][z]);
					}
				}
			}
		}
		
		y = [document.getElementsByTagName('object'),document.getElementsByTagName('embed'),document.getElementsByTagName('applet')];
		for(x = 0; y[x]; x++ ) { 
			for( var z = 0; y[x][z]; z++ ) {
				var oSrc = y[x][z].getAttribute('data');
				if( !oSrc ) { oSrc = y[x][z].getAttribute('src'); }
				if( !oSrc ) { 
					for( var g = 0, h = y[x][z].childNodes[g]; h; g++ ) {
						if( !h.tagName ) { continue; }
						var pName = h.getAttribute('name');
						if( ( pName == 'data' ) || ( pName == 'movie' ) || ( pName == 'src' ) ) {
							oSrc = h.getAttribute('value');
							if( oSrc ) { break; }
						} 
					} 
				}
				if( !oSrc ) { oSrc = y[x][z].getAttribute('code'); }
			
				if( oScr.indexOf("javascript:") < 0){
					if( oSrc && !oSrc.match(matchThis) ) {
						y[x][z].parentNode.removeChild(y[x][z]);
						z--;
					}
				}				
			} 
		}
	//timekeeper = timekeeper + timek.stop();	
	
}
, false);

document.addEventListener("DOMNodeInsertedOFF", 
function(e){ 
	//var timek = new TimeKeeper();  

	deebugp('triggered domnodeinserted event'); 
	deebugp('inserted: attrchange : ' + e.attrChange + ' attrname: ' + e.attrName + ' newvalue: ' + e.newValue + ' oldvalue: ' + e.oldValue + ' relatednode: ' + e.relatedNode.nodeName);
	//e.parentNode.removeChild(e);
	if(e.relatedNode){
		deebugp('relatednode exists');
		var childs = e.relatedNode.childNodes;
		deebugp('relatednode exists:child size = ' + childs.length);
		for(var i = 0; i < childs.length; ++i){
			var nname = childs[i].nodeName?childs[i].nodeName:'no nodename';
			var srcatt = childs[i].getAttribute('src')?childs[i].getAttribute('src'):'no src';
			deebugp('child' + i);
			deebugp('nodename: ' + nname);
			deebugp('src attribute: ' + srcatt);
			if(nname == "IMG" || nname == "IFRAME")
			{
				deebugp('removing node IMG');
				//childs[i].parentNode.removeChild(childs[i]);
			}
		}
	}
	//timekeeper = timekeeper + timek.stop();	

}, false);

// document.addEventListener(
	// 'click',
	// function (e) {
		// var matchThis = new RegExp('^'+location.protocol+'\\\/\\\/'+location.hostname.replace(/\./g,'\\.')+'\\\/','i');
		

		// if(e.target.tagName == 'A')
		// if(e.target.href.indexOf("javascript:") < 0) // ensure not JS URL
		// if(!e.target.href.match(matchThis))
			// e.preventDefault();
// },
// false
// );
